# coding: utf-8

"""
    Fiddle Options Platform

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
from mercury.client.model.spread import Spread
from mercury.client.model.option_contract_type import OptionContractType

import six


class Straddle(Spread):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'symbol': 'str',
        'quantity': 'int',
        'opening_date': 'date',
        'type': 'str',
        'option_legs': 'list[OptionLeg]',
        'direction': 'Direction'

    }

    attribute_map = {
        'symbol': 'symbol',
        'quantity': 'quantity',
        'opening_date': 'openingDate',
        'type': 'type',
        'option_legs': 'optionLegs',
        'direction': 'direction'
    }

    def __init__(self,
                 symbol=None,
                 opening_date=None,
                 quantity=1,
                 call_leg=None,
                 put_leg=None,
                 option_legs=None,
                 type='straddle',
                 direction=None):
        if option_legs is None:
            option_legs = [call_leg, put_leg]
        else:
            call_leg = option_legs[0]
            put_leg = option_legs[1]

        self.discriminator = None

        super(Straddle, self).__init__(
            symbol=symbol,
            opening_date=opening_date,
            quantity=quantity,
            leg1=call_leg,
            leg2=put_leg,
            option_legs=option_legs,
            type=type)

        if call_leg.type != OptionContractType.CALL:
            raise ValueError('Incorrect leg type specified')
        if put_leg.type != OptionContractType.PUT:
            raise ValueError('Incorrect leg type specified')
        if call_leg.direction != put_leg.direction:
            raise ValueError('Call and puts legs should have the same direction')
        if call_leg.quantity_abs != put_leg.quantity_abs:
            raise ValueError('Call and put legs have different quantities')
        if call_leg.expiration_date != put_leg.expiration_date:
            raise ValueError('Call and put legs have different expirations')
        if call_leg.strike != put_leg.strike:
            raise ValueError('Call and put legs have different strikes')

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Straddle):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
